SystemOrganization addCategory: #ABTesting!

Object subclass: #ABGTest
	instanceVariableNames: 'aYes bYes aNo bNo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ABTesting'!

!ABGTest commentStamp: 'PaulDeBruicker 3/31/2010 12:11' prior: 0!
ABGTest is designed to calculate and return the confidence level of the results of an ABtest.  It relies on the Chi Squared distribution from the DHB Numerics package on squeaksouce.



Instance Variables
	aNo:		# of no answers for test case A
	aYes:		# of Yes answers for test case A
	bNo:		# of no answers for test case B
	bYes:		# of Yes answers for test case B

!

!ABGTest class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 3/30/2010 23:31'!
getPValueWithAYes: aYes aNo: aNo bYes:bYes bNo:bNo 
|x|
	x:=ABGTest new
					aYes: aYes;
					aNo: aNo;
					bYes: bYes;
					bNo: bNo.
	^x pValue.! !

!ABGTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/30/2010 23:11'!
a
	^aNo+aYes.! !

!ABGTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/30/2010 23:11'!
aNo
	^ aNo! !

!ABGTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/30/2010 23:11'!
aNo: anObject
	aNo := anObject! !

!ABGTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/30/2010 23:11'!
aYes
	^ aYes! !

!ABGTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/30/2010 23:11'!
aYes: anObject
	aYes := anObject! !

!ABGTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/30/2010 23:11'!
b
	^bNo+bYes.! !

!ABGTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/30/2010 23:11'!
bNo
	^ bNo! !

!ABGTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/30/2010 23:11'!
bNo: anObject
	bNo := anObject! !

!ABGTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/30/2010 23:11'!
bYes
	^ bYes! !

!ABGTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/30/2010 23:11'!
bYes: anObject
	bYes := anObject! !

!ABGTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 14:12'!
expectedANo
	^(self a)*(self no)/(self total)! !

!ABGTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 14:13'!
expectedAYes
	^(self a)*(self yes)/(self total)! !

!ABGTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 14:13'!
expectedBNo
	^(self b)*(self no)/(self total)! !

!ABGTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 14:13'!
expectedBYes
	^(self b)*(self yes)/(self total)! !

!ABGTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 14:13'!
gTest
	|x| 
	
	x:=2*((aYes *(aYes/self expectedAYes )ln)
	+(bYes *(bYes/self expectedBYes )ln)
	+(aNo *(aNo/self expectedANo )ln)
	+(bNo *(bNo/self expectedBNo )ln) ).

^x.! !

!ABGTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/30/2010 23:12'!
no
	^aNo+bNo! !

!ABGTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 14:11'!
pValue

	|x y|
	x:=DhbChiSquareDistribution degreeOfFreedom: 1.
	y:=(x confidenceLevel: self gTest).
	

	^y/100.
! !

!ABGTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/30/2010 23:28'!
pValue: aNumber

	|x|
	x:=DhbChiSquareDistribution degreeOfFreedom: 1.
	^x 	confidenceLevel: aNumber/100 .
! !

!ABGTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/30/2010 23:12'!
total
	^aNo+bNo+aYes+bYes! !

!ABGTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/30/2010 23:11'!
yes
	^aYes+bYes! !

Object subclass: #ABTest
	instanceVariableNames: 'testName goal description startDate winner endDate a b aYes aViews bViews bYes aConverts bConverts enoughResults highConfidence'
	classVariableNames: 'DesiredConfidenceLevel'
	poolDictionaries: ''
	category: 'ABTesting'!

ABTest class
	instanceVariableNames: 'tests users'!

!ABTest commentStamp: 'PaulDeBruicker 3/31/2010 18:16' prior: 0!
The user should see the same result each visit or page view until a winner has been declared. 

Set #winner equal to a non nil value to stop the test and use the winning result.  

Once the #confidenceLevel goes above the class var DesiredConfidenceLevel the code will set the winner for the test .

Each test needs to have a unique name.  You should not change the A or B option once the test starts, as that would invalidate your results.  


Other things to add include:
		use cookies rather than users, and switch from cookies to users once someone creates an account.  
		persistent storage of the tests and results. Right now the results are kept in the class ivar #tests in the image.
		weighting the tests so that A shows 90% of the time and B shows 10% or some other proportion.  Right now, it should be an even split
		Have a way to deal with more than two choices, e.g fractional factorial designs http://en.wikipedia.org/wiki/Fractional_factorial_design .
		integrate the concepts from here: http://wiki.github.com/gregdingle/genetify/  


Some resources:
http://en.wikipedia.org/wiki/A/B_Testing
http://elem.com/~btilly/effective-ab-testing/
http://www.slideshare.net/patio11/ab-testing-framework-design-3296257?from=ss_embed
http://www.bingocardcreator.com/abingo/
http://vanity.labnotes.org/ab_testing.html!

ABTest class
	instanceVariableNames: 'tests users'!

!ABTest class methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 13:59'!
DesiredConfidenceLevel
	"0.99 means you are 99% confident of the winner."
	
	^DesiredConfidenceLevel ! !

!ABTest class methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 13:59'!
DesiredConfidenceLevel: aNumber
	"0.99 means you are 99% confident of the winner."
	
	DesiredConfidenceLevel:=aNumber  ! !

!ABTest class methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/1/2010 11:22'!
initializeNewProject
ABTest users: Dictionary new.
ABTest tests: Dictionary new.! !

!ABTest class methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 10:55'!
newTest: aName a: optionA b: optionB
|x|
x:=ABTest new
			testName: aName;
			a: optionA;
			b: optionB.
tests at: aName put: x.

^x! !

!ABTest class methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/1/2010 18:17'!
recordConversion: aTestName by: aUser

|test version user |

test:=tests at: aTestName.
user:= users at: aUser.
version:= user at: aTestName.

(test a = version ) ifTrue: [(test aConverts includes: aUser) ifFalse:[test aYes: test aYes+1.
						test aConverts add: aUser]] .
(test b = version ) ifTrue: [(test bConverts includes: aUser) ifFalse:[test bYes: test bYes+1.
						test bConverts add: aUser]].
test winner ifNil:[ test testResults].
tests at: aTestName put: test.! !

!ABTest class methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/1/2010 18:15'!
showVariation: aTestName a: optionA b: optionB user: aUser
|show test user |
	
	(users includesKey: aUser) ifFalse:[users at: aUser put: Dictionary new]. 
	user:=users at: aUser.
	test:=tests at: aTestName ifAbsent:[self newTest: aTestName a: optionA   b: optionB ].
	show := test winner.
	
show ifNil:[
				(user includesKey: aTestName)
					 ifTrue:[ show:=user at: aTestName] 
					ifFalse:[show:=test getAorB.
							user at: aTestName put: show.
					
				(show=optionA )
					ifTrue:[test aViews: test aViews +1]
					ifFalse:[test bViews: test bViews +1]].
				tests at: aTestName put: test.].
	^show! !

!ABTest class methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 16:50'!
tests
	^ tests! !

!ABTest class methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 10:25'!
tests: anObject
	tests := anObject! !

!ABTest class methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 17:46'!
users
	^ users! !

!ABTest class methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 17:46'!
users: anObject
	users := anObject! !

!ABTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 10:25'!
a
	^ a! !

!ABTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 10:25'!
a: anObject
	a := anObject! !

!ABTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 12:35'!
aConversion
^(aYes /aViews )! !

!ABTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 12:42'!
aConverts
	^ aConverts! !

!ABTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 12:42'!
aConverts: anObject
	aConverts := anObject! !

!ABTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 11:00'!
aViews
	^ aViews! !

!ABTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 11:00'!
aViews: anObject
	aViews := anObject! !

!ABTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 11:00'!
aYes
	^ aYes! !

!ABTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 11:00'!
aYes: anObject
	aYes := anObject! !

!ABTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 10:25'!
b
	^ b! !

!ABTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 10:25'!
b: anObject
	b := anObject! !

!ABTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 12:35'!
bConversion
^(bYes /bViews )! !

!ABTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 12:42'!
bConverts
	^ bConverts! !

!ABTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 12:42'!
bConverts: anObject
	bConverts := anObject! !

!ABTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 11:00'!
bViews
	^ bViews! !

!ABTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 11:00'!
bViews: anObject
	bViews := anObject! !

!ABTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 11:00'!
bYes
	^ bYes! !

!ABTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 11:00'!
bYes: anObject
	bYes := anObject! !

!ABTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 11:04'!
confidenceLevel
 |cl x aNo bNo|
	cl:=0.
	self views = 0 ifFalse:[aNo:=aViews - aYes.
							bNo := bViews - bYes.
							cl:=ABGTest getPValueWithAYes: aYes aNo: aNo bYes: bYes bNo: bNo].
	^cl! !

!ABTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 10:25'!
description
	^ description! !

!ABTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 10:25'!
description: anObject
	description := anObject! !

!ABTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 10:25'!
endDate
	^ endDate! !

!ABTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 10:25'!
endDate: anObject
	endDate := anObject! !

!ABTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 12:59'!
enoughResults
	^ enoughResults! !

!ABTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 12:59'!
enoughResults: anObject
	enoughResults := anObject! !

!ABTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 11:31'!
getAorB 
|x|
x:=a.


	(2 atRandom =1) ifFalse:[x:=b].
	
^x! !

!ABTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 10:25'!
goal
	^ goal! !

!ABTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 10:25'!
goal: anObject
	goal := anObject! !

!ABTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 12:59'!
highConfidence
	^ highConfidence! !

!ABTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 12:59'!
highConfidence: anObject
	highConfidence := anObject! !

!ABTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 16:55'!
initialize 

	super initialize .
	startDate:=DateAndTime now.
	aYes:=bYes:=aViews:=bViews :=0.
	winner:=nil.
	aConverts :=OrderedCollection new.
	bConverts :=OrderedCollection new.
	enoughResults := false.
	highConfidence := false.
	DesiredConfidenceLevel :=0.99.

! !

!ABTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 17:21'!
showTestResults
|resultString|


self enoughResults ifFalse: [resultString:='Not Enough Conversions'] 

					ifTrue:[self highConfidence
								ifTrue:[resultString:=((1- self confidenceLevel) asString truncateTo: 4) , ' (A: ' , (self aConversion asFloat asString truncateTo:4) ,' vs. B: ' , (self bConversion asFloat asString truncateTo:4) , ') ' ]
								ifFalse: [resultString:='Too close to call: ' , ((1- self confidenceLevel) asString truncateTo: 4) , ' (A: ' , (self aConversion asFloat asString truncateTo:4) ,' vs. B: ' , (self bConversion asFloat asString truncateTo:4) , ') ' ]].
							
		^resultString ! !

!ABTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 10:25'!
startDate
	^ startDate! !

!ABTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 10:25'!
startDate: anObject
	startDate := anObject! !

!ABTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 15:30'!
testDuration
|x durationString| 
durationString:='Test incomplete'.
endDate notNil ifTrue:[
							x:= endDate - startDate.
							durationString :=	x days asString, ' days, ' , x hours asString , ' hours, ' , x minutes asString, ' minutes '].
^durationString .! !

!ABTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 10:25'!
testName
	^ testName! !

!ABTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 10:25'!
testName: anObject
	testName := anObject! !

!ABTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 15:15'!
testResults

((aYes >10)&(bYes>10))
	ifTrue:[	enoughResults:=true.
			(self confidenceLevel < (1-DesiredConfidenceLevel ))
				ifTrue: [highConfidence:=true.
						(self aConversion > self bConversion)
							 ifTrue:[winner:=a.
									endDate:=DateAndTime now.]
							 ifFalse:[winner:=b.
									endDate:=DateAndTime now. ]]]! !

!ABTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 11:00'!
views
	^ aViews+bViews! !

!ABTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 10:25'!
winner
	^ winner! !

!ABTest methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 11:23'!
winner:testWinner
	 winner:=testWinner! !

Object subclass: #ABUser
	instanceVariableNames: 'abTests'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ABTesting'!

!ABUser commentStamp: 'PaulDeBruicker 3/31/2010 18:16' prior: 0!
This is just a User class for testing the AB Testing package.  !

!ABUser methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 17:14'!
abTests
	^ abTests! !

!ABUser methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 17:14'!
abTests: anObject
	abTests := anObject! !

!ABUser methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 3/31/2010 17:09'!
initialize 
	super initialize .
	abTests:=Dictionary new.! !

WAComponent subclass: #ABDashboard
	instanceVariableNames: 'tests testTable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ABTesting'!

!ABDashboard commentStamp: 'PaulDeBruicker 3/31/2010 18:16' prior: 0!
Just a simple component to show the results of all of the tests 

see the renderExampleOn: method.  !

!ABDashboard methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 17:22'!
exampleABTests 
	|x| 
	x := Dictionary new.
	x at: 'first' put:(ABTest new
	
					testName:'first'; 
					a: (WARenderCanvas builder render:[:h | h div
																	style:'background-color: #ffffff; width: 50px;height 50px';
																	with:'A first test' ]   ); 
					b: (WARenderCanvas builder render:[:h | h div
																	style:'background-color: #BBBBBB; width: 80px; height: 80px';
																	with:'B first test' ]   );
					aYes: 100;
					aViews:150;
					bViews:147;
					bYes:25 ).
		x at: 'second' put:(ABTest new
	
					testName:'second'; 
					a:(WARenderCanvas builder render:[:h | h image
																	url:'http://www.seaside.st/styles/logo-plain.png'
																	 ]   ); 
					b: (WARenderCanvas builder render:[:h | h image
																	url:'http://www.seaside.st/styles/esug.gif'
																	 ]   ); 
					aYes: 24;
					aViews:150;
					bViews:147;
					bYes:25 ).
				x at: 'third' put:(ABTest new
	
					testName:'third'; 
					a:'Some text for the third test. Version A'; 
					b: 'Some other text for the third test, Version B';
					aYes: 1;
					aViews:150;
					bViews:147;
					bYes:2 ).
				^x.! !

!ABDashboard methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 16:43'!
initialize 

	super initialize.
	testTable:=WATableReport new
					columns: (OrderedCollection new
							add:( (WAReportColumn 
								selector: #testName title:'Test Name')
								sortBlock:[:a :b | a ]);
							add: ((WAReportColumn 
								new title:'Winner')	
									valueBlock: [:each :html | each testResults.
										 each winner ifNotNil:[html html: each winner]]);	
							add:((WAReportColumn new title:'Confidence Level')
								valueBlock:[:e | e showTestResults  ]);				
							add: ((WAReportColumn 
								new title:'A'	)
									valueBlock: [:each :html | html html: each a ]);								
							add: ((WAReportColumn 
								new title:'B'	)
									valueBlock: [:each :html | html html: each b ]);

							add: ((WAReportColumn new
								title:'# of Views')
								valueBlock: [:e | e views];	
								sortBlock:[:a :b | a ]);
							add: ((WAReportColumn 
								selector: #startDate title:'Start Date')	
								sortBlock:[:a :b | a ]);	
							add: ((WAReportColumn 
								new title:'Test Duration')									
								valueBlock:[:each | each testDuration]);			
							add: (WAReportColumn 
								selector: #goal title:'Goal');
							add: (WAReportColumn 
								selector: #description title:'Description');															
								yourself);
					rowColors: #(lightblue lightyellow);
					rowPeriod: 1;
					yourself.! !

!ABDashboard methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 13:55'!
renderContentOn: html
testTable rows: tests values asOrderedCollection.
  html render: testTable.! !

!ABDashboard methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 17:36'!
renderExampleOn: html
testTable rows: (self exampleABTests  values asOrderedCollection).
  html render: testTable.! !

!ABDashboard methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 16:13'!
tests
	^ tests ifNil: [tests:=self exampleABTests ]! !

!ABDashboard methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/31/2010 00:05'!
tests: aCollectionOfABTests
	tests := aCollectionOfABTests ! !
